package hatenahaiku4j.util;

import hatenahaiku4j.Const;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * XMLɊւ郆[eBeBNX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class XmlUtil {

	/**
	 * XML񂩂A[gGg擾܂B
	 * 
	 * @param resultXml XML
	 * @return [gGg
	 * @throws ParserConfigurationException
	 * @throws UnsupportedEncodingException
	 * @throws SAXException
	 * @throws IOException
	 * @since v0.0.1
	 */
	public static Element getRootElement(String resultXml) throws ParserConfigurationException, UnsupportedEncodingException, SAXException, IOException {
		// hLgr_[t@Ng𐶐
		DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
		// hLgr_[𐶐
		DocumentBuilder builder = dbfactory.newDocumentBuilder();
		// p[XsDocumentIuWFNg擾
		Document doc = builder.parse(new ByteArrayInputStream(resultXml.getBytes(Const.UTF8)));

		return doc.getDocumentElement();
	}
	
	/**
	 * XMLm[hqm[h̃Gg擾ԋp܂B
	 * 
	 * @param node _ƂȂXMLm[h
	 * @return qm[h̃GgXg
	 * @since v0.1.0
	 */
	public static List<Element> getChildElements(Node node) {
		List<Element> result = new ArrayList<Element>();
		NodeList nodeList = node.getChildNodes();
		for (int i = 0; i < nodeList.getLength(); i++) {
			Node child = nodeList.item(i);
			if (child.getNodeType() == Node.ELEMENT_NODE) {
				result.add((Element) child);
			}
		}
		return result;
	}

	/**
	 * XMLGgw̃^Oqm[h̃Ggԋp܂B
	 * 
	 * @param elem _ƂȂXMLGg
	 * @param name ^O
	 * @return ^OɃ}b`1ڂ̃Gg
	 * @since v0.1.0
	 */
	public static List<Element> getChildElementsByTagName(Element elem, String name) {
		List<Element> result = new ArrayList<Element>();
		NodeList nodeList = elem.getChildNodes();
		for (int i = 0; i < nodeList.getLength(); i++) {
			Node child = nodeList.item(i);
			if (child.getNodeType() == Node.ELEMENT_NODE
					&& child.getNodeName().equals(name)) {
				result.add((Element) child);
			}
		}
		return result;
	}

	/**
	 * XMLGgw̃^OGg̐擪1ڂԋp܂B<br/>
	 * Ȃꍇnullԋp܂B
	 * 
	 * @param elem _ƂȂXMLGg
	 * @param name ^O
	 * @return ^OɃ}b`1ڂ̃Gg
	 * @since v0.1.0
	 */
	public static Element getFirstChildElement(Element elem, String name) {
		NodeList nodeList = elem.getChildNodes();
		for (int i = 0; i < nodeList.getLength(); i++) {
			Node child = nodeList.item(i);
			if (child.getNodeType() == Node.ELEMENT_NODE
					&& child.getNodeName().equals(name)) {
				return (Element) child;
			}
		}
		return null;
	}

	/**
	 * XMLGgw̃^OGg̐擪1ڂ̃eLXgRecԋp܂B
	 * 
	 * @param elem _ƂȂXMLGg
	 * @param name ^O
	 * @return ^OɃ}b`1ڂ̃Gg̃eLXgRec
	 * @since v0.0.1
	 */
	public static String getText(Element elem, String name) {
		Element childElement = getFirstChildElement(elem, name);
		if (childElement == null) {
			return "";
		}
		Node node = childElement.getFirstChild();
		return node == null ? "" : node.getTextContent();
	}
	
	/**
	 * XMLGgw̃^OGgׂẴeLXgRecXgŕԋp܂B
	 * 
	 * @param elem _ƂȂXMLGg
	 * @param name ^O
	 * @return ^OɃ}b`vf̃Gg̃eLXgRec̃Xg
	 * @since v0.0.1
	 */
	public static List<String> getTextList(Element elem, String name) {
		List<String> result = new ArrayList<String>();
		List<Element> childElements = getChildElementsByTagName(elem, name);
		for (Element childElem : childElements) {
			Node node = childElem.getFirstChild();
			result.add(node == null ? "" : node.getTextContent());
		}
		return result;
	}
}
